(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('fp-ts/lib/Either'), require('rxjs/operators'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('rxjs-fp-operators', ['exports', 'fp-ts/lib/Either', 'rxjs/operators', 'rxjs'], factory) :
    (factory((global['rxjs-fp-operators'] = {}),global.Either,global.rxjs.operators,global.rxjs));
}(this, (function (exports,Either,operators,rxjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T, L
     * @param {?} recover
     * @return {?}
     */
    function recoverWith(recover) {
        return function (source) { return source.pipe(operators.map(function (v) { return Either.right(v); }), operators.catchError(function (error) { return recover(error); })); };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T, L
     * @param {?} selector
     * @return {?}
     */
    function recover(selector) {
        return recoverWith(function (error) { return rxjs.of(selector(error)); });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.recoverWith = recoverWith;
    exports.recover = recover;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=rxjs-fp-operators.umd.js.map